/**
 * @athenna/core
 *
 * (c) João Lenon <lenon@athenna.io>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
import { ArtisanImpl } from '@athenna/artisan';
import { ArtisanOptions } from '#src/Types/ArtisanOptions';
export declare class Artisan {
    /**
     * Load the necessary stuff before booting Artisan.
     */
    static load(): Promise<void>;
    /**
     * Boot the Artisan application and execute the commands of argv.
     */
    static boot(argv: string[], options?: ArtisanOptions): Promise<ArtisanImpl>;
    /**
     * Resolve the kernel by importing it and calling the methods to register
     * commands, routes and console exception handler.
     */
    private static resolveKernel;
}
