/**
 * @athenna/core
 *
 * (c) João Lenon <lenon@athenna.io>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Module, Path } from '@athenna/common';
import { BaseCommand, Option } from '@athenna/artisan';
export class ServeCommand extends BaseCommand {
    watch;
    env;
    static settings() {
        return {
            stayAlive: true,
        };
    }
    static signature() {
        return 'serve';
    }
    static description() {
        return 'Serve your application.';
    }
    async handle() {
        if (this.env !== '') {
            process.env.NODE_ENV = this.env;
        }
        if (this.watch) {
            let execCmd = "'npm run start --silent'";
            const nodemon = await import('nodemon');
            const ignorePaths = `--ignore ${Path.tests()} ${Path.storage()} ${Path.nodeModules()}`;
            if (Env('NODEMON_NPM_ARGS', '') !== '') {
                execCmd = execCmd.concat(' ', Env('NODEMON_NPM_ARGS'));
            }
            nodemon.default(`--quiet ${ignorePaths} --watch ${Path.pwd()} --exec ${execCmd}`);
        }
        const entrypoint = Config.get('rc.commandsManifest.serve.entrypoint', '#bootstrap/main');
        await Module.resolve(entrypoint, Config.get('rc.meta'));
    }
}
__decorate([
    Option({
        signature: '-w, --watch',
        description: 'Watch for file changes and re-start the application on changes.',
        default: false,
    })
], ServeCommand.prototype, "watch", void 0);
__decorate([
    Option({
        signature: '-e, --env <env>',
        description: 'Change the evironment where the application will run. Default is ""',
        default: '',
    })
], ServeCommand.prototype, "env", void 0);
