/**
 * @athenna/core
 *
 * (c) João Lenon <lenon@athenna.io>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Module } from '@athenna/common';
import { BaseCommand, Option } from '@athenna/artisan';
export class TestCommand extends BaseCommand {
    e2e;
    unit;
    env;
    debug;
    static settings() {
        return {
            stayAlive: true,
        };
    }
    static signature() {
        return 'test';
    }
    static description() {
        return 'Run the tests of your application.';
    }
    async handle() {
        if (this.env !== '') {
            process.env.NODE_ENV = this.env;
        }
        const protectedArgs = ['--e2e', '--unit', '--debug'];
        process.argv = process.argv.filter(arg => !protectedArgs.includes(arg));
        if (this.e2e) {
            process.argv.push('E2E');
        }
        if (this.unit) {
            process.argv.push('Unit');
        }
        if (this.debug) {
            process.env.DEBUG = 'api:*';
        }
        const entrypoint = Config.get('rc.commandsManifest.test.entrypoint', '#bootstrap/test');
        await Module.resolve(entrypoint, Config.get('rc.meta'));
    }
}
__decorate([
    Option({
        signature: '--e2e',
        description: 'Run only e2e test suite.',
        default: false,
    })
], TestCommand.prototype, "e2e", void 0);
__decorate([
    Option({
        signature: '--unit',
        description: 'Run only unit test suite.',
        default: false,
    })
], TestCommand.prototype, "unit", void 0);
__decorate([
    Option({
        signature: '-e, --env <env>',
        description: 'Change the evironment where your tests wil run. Default is "test"',
        default: 'test',
    })
], TestCommand.prototype, "env", void 0);
__decorate([
    Option({
        signature: '--debug',
        description: 'Enable API debug mode to see more logs.',
        default: false,
    })
], TestCommand.prototype, "debug", void 0);
